import { Tenant } from "@webiny/api-tenancy/types";
import { Base } from "./base.crud";
import { UserPlugin } from "../plugins/UserPlugin";
import { AdminUsersContext, CreatePersonalAccessTokenInput, CreateUserInput, Group, TenantAccess, UpdatePersonalAccessTokenInput, UpdateUserInput, User, UserPersonalAccessToken, UsersCRUD } from "../types";
export declare class Users extends Base implements UsersCRUD {
    private loaders;
    constructor(context: AdminUsersContext);
    get plugins(): UserPlugin[];
    login(): Promise<User>;
    createToken(login: string, data: CreatePersonalAccessTokenInput): Promise<UserPersonalAccessToken>;
    createUser(data: CreateUserInput, options?: {
        auth?: boolean;
    }): Promise<User>;
    deleteToken(login: string, tokenId: string): Promise<boolean>;
    deleteUser(login: string): Promise<boolean>;
    getPersonalAccessToken(login: string, tokenId: string): Promise<UserPersonalAccessToken>;
    getUser(login: string, options?: {
        auth?: boolean;
    }): Promise<User>;
    getUserAccess(login: string): Promise<TenantAccess[]>;
    getUserByPersonalAccessToken(token: string): Promise<User>;
    linkUserToTenant(login: string, tenant: Tenant, group: Group): Promise<void>;
    listTokens(login: string): Promise<UserPersonalAccessToken[]>;
    listUsers(params?: {
        tenant?: string;
        auth?: boolean;
    }): Promise<User[]>;
    unlinkUserFromTenant(login: string, tenant: Tenant): Promise<void>;
    updateToken(login: string, tokenId: string, data: UpdatePersonalAccessTokenInput): Promise<UpdatePersonalAccessTokenInput>;
    updateUser(login: string, data: UpdateUserInput): Promise<User>;
}
